package br.com.tecpoint.api;

import com.sun.jna.Pointer;
import com.sun.jna.Structure;

/**
 * The CompressedImage structure has two members:<br>
·         BYTE * pBuffer : the buffer pointer.<br>
·         int BufferLen : the length of the buffer for the compressed images or snippets.<br>
          If an image is not requested the corresponding buffer pointer is NULL and the buffer length is 0
 * @param pBuffer  - the buffer pointer
 * @param bufferLen - the length of the buffer for the compressed images or snippets
 * @author Cirilo Veloso
 * @see imagesStruct
 */
public class CompressedImage extends Structure {

    public static class ByRef extends CompressedImage implements Structure.ByReference {
    }

    public CompressedImage() {
        setAlignType(ALIGN_MSVC);
    }
    //BYTE *pBuffer;
    public Pointer pBuffer;
    //int BufferLen;
    public int bufferLen;
}
