/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package br.com.tecpoint.api;

import com.sun.jna.Structure;

/**
 * The font of the text is defined as a Win32 LOGFONT structure. The default font for
    every area is Arial, the size is 10 and the weight is 600 (FW_SEMIBOLD). The font
    size has to be defined greater than 0 (negative it isn’t accepted). The size is expressed
    in points (1/72 of an inch). The font size is automatically scaled to the image
    resolution.<br>
 *@version 1.00
 *@author Cirilo Veloso
 *@see sendPrinterData
 */
public class LogFont extends Structure {

    public final int FW_DONTCARE = 0;
    public final int FW_THIN = 100;
    public final int FW_EXTRALIGHT = 200;
    public final int FW_ULTRALIGHT = 200;
    public final int FW_LIGHT = 300;
    public final int FW_NORMAL = 400;
    public final int FW_REGULAR = 400;
    public final int FW_MEDIUM = 500;
    public final int FW_SEMIBOLD = 600;
    public final int FW_DEMIBOLD = 600;
    public final int FW_BOLD = 700;
    public final int FW_EXTRABOLD = 800;
    public final int FW_ULTRABOLD = 800;
    public final int FW_HEAVY = 900;
    public final int FW_BLACK = 900;
    //
    public final byte ANSI_CHARSET = 0;
    public final byte ARABIC_CHARSET = (byte) 178;
    public final byte BALTIC_CHARSET = (byte) 186;
    public final byte CHINESEBIG5_CHARSET = (byte) 136;
    public final byte DEFAULT_CHARSET = (byte) 1;
    public final byte EASTEUROPE_CHARSET = (byte) 238;
    public final byte GB2312_CHARSET = (byte) 134;
    public final byte GREEK_CHARSET = (byte) 161;
    public final byte HANGEUL_CHARSET = (byte) 129;
    public final byte HEBREW_CHARSET = (byte) 177;
    public final byte JOHAB_CHARSET = (byte) 130;
    public final byte MAC_CHARSET = (byte) 77;
    public final byte OEM_CHARSET = (byte) 255;
    public final byte RUSSIAN_CHARSET = (byte) 204;
    public final byte SHIFTJIS_CHARSET = (byte) 128;
    public final byte SYMBOL_CHARSET = (byte) 2;
    public final byte THAI_CHARSET = (byte) 222;
    public final byte TURKISH_CHARSET = (byte) 162;
    //
    public final byte OUT_DEFAULT_PRECIS = (byte) 0;
    public final byte OUT_DEVICE_PRECIS = (byte) 5;
    public final byte OUT_OUTLINE_PRECIS = (byte) 8;
    public final byte OUT_RASTER_PRECIS = (byte) 6;
    public final byte OUT_STRING_PRECIS = (byte) 1;
    public final byte OUT_STROKE_PRECIS = (byte) 3;
    public final byte OUT_TT_ONLY_PRECIS = (byte) 7;
    public final byte OUT_TT_PRECIS = (byte) 4;
    //
    public final byte CLIP_DEFAULT_PRECIS = (byte) 0;
    public final byte CLIP_EMBEDDED = (byte) 128;
    public final byte CLIP_LH_ANGLES = (byte) 16;
    public final byte CLIP_STROKE_PRECIS = (byte) 2;
    //
    public final byte ANTIALIASED_QUALITY = (byte) 4;
    public final byte DEFAULT_QUALITY = (byte) 0;
    public final byte DRAFT_QUALITY = (byte) 1;
    public final byte NONANTIALIASED_QUALITY = (byte) 3;
    public final byte PROOF_QUALITY = (byte) 2;
    //
    public final byte DEFAULT_PITCH = (byte) 0;
    public final byte FIXED_PITCH = (byte) 1;
    public final byte VARIABLE_PITCH = 2;
    public final byte FF_DECORATIVE = (byte) 80;
    public final byte FF_DONTCARE = (byte) 0;
    public final byte FF_ROMAN = (byte) 16;
    public final byte FF_SCRIPT = (byte) 64;
    public final byte FF_SWISS = (byte) 32;
    public final int LF_FACESIZE = 32;

    public LogFont() {
        setAlignType(Structure.ALIGN_MSVC);
    }

    public LogFont(String fontName) {
        setAlignType(Structure.ALIGN_MSVC);
        this.lfFaceName = fontName.getBytes();
    }

    public LogFont(String fontName, int fontWeight) {
        setAlignType(Structure.ALIGN_MSVC);
        this.lfFaceName = fontName.getBytes();
        this.lfWeight = fontWeight;
    }
    public int lfHeight = -13;
    public int lfWidth = 0;
    public int lfEscapement = 0;
    public int lfOrientation = 0;
    public int lfWeight = FW_BOLD;
    public byte lfItalic = (byte)0;
    public byte lfUnderline = (byte)0;
    public byte lfStrikeOut = (byte)0;
    public byte lfCharSet = DEFAULT_CHARSET;
    public byte lfOutPrecision = OUT_DEFAULT_PRECIS;
    public byte lfClipPrecision = CLIP_DEFAULT_PRECIS;
    public byte lfQuality = PROOF_QUALITY;
    public byte lfPitchAndFamily = DEFAULT_PITCH;
    public byte[] lfFaceName = new byte[LF_FACESIZE];
}
