package br.com.tecpoint.api;

import com.sun.jna.Structure;

//typedef struct _Snippet
/**
 * Snippet Structure
 * @author Cirilo Veloso
 * @version 1.00
 * @see setDeviceParameters
 */
public class Snippet extends Structure {

    public static class ByValue extends Snippet implements Structure.ByValue {
    }

    public Snippet() {
        setAlignType(ALIGN_MSVC);
    }
    public int Xposition;   // X position of the Snippet.
    // Referred to the LOWER-RIGHT corner for the FRONT side
    // Referred to the LOWER-LEFT corner for the REAR side
    public int Yposition;   // Y position of the Snippet
    // Referred to the BOTTOM of the document
    public int Width;       // Snippet Width
    public int Height;      // Snippet Height
    public int Orientation; // Snippet Orientation
    public int Color;       // Snippet Color
    public int Compression; // Compression Format (Not Yet Implemented)
    public int Millimeters; // Units
}
