package br.com.tecpoint.api;

import br.com.tecpoint.api.win32.W32API.HWND;

/**
 * VisionAPI interface
 * @author Cirilo Veloso
 * @version 1.00
 */
public interface VAPIInterface {

	public static final int WM_PANINI = 32778;
	public static final int TRUE = (1);
	public static final int FALSE = (0);

	public static final int HOPPER_FEED = 0;
	public static final int DROP_FEED   = 1;

	public static final int MICR_FONT_CMC7     = (0);
	public static final int MICR_FONT_E13B     = (1);
	public static final int MICR_FONT_AUTO     = (2);
	public static final int MICR_FONT_E13B_OCR = (3);
	public static final int MICR_FONT_CMC7_OCR = (4);
	public static final int MICR_FONT_AUTO_OCR = (5);

	public static final int SPACES_NONE = 0;
	public static final int SPACES_ONE  = 1;
	public static final int SPACES_ALL  = 2;

	public static final int PRINTER_DISABLE               = 0x00000000;
	public static final int PRINTER_ENABLE_LEADING_EDGE   = 0x00000001;
	public static final int PRINTER_ENABLE_TRAILING_EDGE  = 0x00000003;

	public static final int PRINTER_AGP_QUALITY_NORMAL   = 0x00000000;
	public static final int PRINTER_AGP_QUALITY_HIGHQ    = 0x00000100;
	public static final int PRINTER_AGP_QUALITY_DRAFT    = 0x00000200;

	public static final int PRINTER_ENABLE_SMART_JET     = 0x00010000;

	public static final int PRINTER_VIRTUAL_ENABLE       = 0x01000000;

	public static final int FORMAT_NONE                 = 0;
	public static final int FORMAT_GIV                  = 1;
	public static final int FORMAT_JPEG                 = 2;
	public static final int FORMAT_BMP                  = 3;
	public static final int FORMAT_NATIVE_BMP           = 4;
	public static final int FORMAT_BMP_COLOR            = 5;
	public static final int FORMAT_JPEG_COLOR           = 6;
	public static final int FORMAT_GIV_DROP_OUT_RED     = 7;
	public static final int FORMAT_GIV_DROP_OUT_GREEN   = 8;
	public static final int FORMAT_GIV_DROP_OUT_BLUE    = 9;
	public static final int FORMAT_BMP_TRUE_COLOR       =10;
	public static final int FORMAT_JPEG_TRUE_COLOR      =11;
	public static final int FORMAT_GIV_DOR_TRUE_COLOR   =12;
	public static final int FORMAT_GIV_DOG_TRUE_COLOR   =13;
	public static final int FORMAT_GIV_DOB_TRUE_COLOR   =14;
	public static final int FORMAT_GIV_DROP_OUT_IR      =15;

	public static final int FRANKED_IMAGE               = 0x00010000;
	public static final int COMP_IMAGE_FOR_DECISION     = 0x00020000;

	public static final int PAGING_ONLY_SINGLE  = 0;
	public static final int PAGING_ONLY_MULTI   = 1;
	public static final int PAGING_SINGLE_MULTI = 2;

	public static final int RESOLUTION_100 = 100;
	public static final int RESOLUTION_200 = 200;
	public static final int RESOLUTION_300 = 300;

	public static final int SNIPPET_ENABLE               = 0x00000001;
	public static final int SNIPPET_ENABLE_FOR_DECISION  =(0x00000100|SNIPPET_ENABLE);
	public static final int SNIPPET_DISABLE              = 0x00000000;

	public static final int SNIPPET_ORIENTATION_NORMAL                    = 0;    
	public static final int SNIPPET_ORIENTATION_CCW_90_DEG_ROT            = 1;   
	public static final int SNIPPET_ORIENTATION_UPSIDE_DOWN               = 2;
	public static final int SNIPPET_ORIENTATION_CW_90_DEG_ROT             = 3;
	public static final int SNIPPET_ORIENTATION_VERTICAL_MIRROR           = 4;
	public static final int SNIPPET_ORIENTATION_CCW_90_DEG_ROT_VERT_MIR   = 5;
	public static final int SNIPPET_ORIENTATION_UPSIDE_DOWN_VERT_MIRROR   = 6;
	public static final int SNIPPET_ORIENTATION_CW_90_DEG_ROT_VERT_MIR    = 7;

	public static final int SNIPPET_COLOR_GREY_LEVEL    = 0;
	public static final int SNIPPET_COLOR_BLACK_WHITE   = 1;
	public static final int SNIPPET_COLOR_COLOR         = 2;

	public static final int DeviceShutDown              = 0;
	public static final int DeviceStartingUp            = 1;
	public static final int DeviceShuttingDown          = 2;
	public static final int DeviceChangeParameters      = 3;
	public static final int DeviceChangingParameters    = 4;
	public static final int DeviceOnLine                = 5;
	public static final int DeviceOffLine               = 6;
	public static final int DeviceStandBy               = 7;
	public static final int DeviceFeeding               = 8;
	public static final int DeviceExceptionInProgress   = 9;
	public static final int DeviceLocked                =10;

	public static final int WMPAR_SORTER_CONNECTED                = 0;
	public static final int WMPAR_SORTER_DISCONNECTED             = 1;
	public static final int WMPAR_SORTER_NEW_DOCUMENT             = 2;
	public static final int WMPAR_SORTER_MICR_AVAILABLE           = 3;
	public static final int WMPAR_SORTER_SET_ITEM_OUTPUT          = 4;
	public static final int WMPAR_SORTER_DOCUMENT_INSIDE_POCKET   = 5;
	public static final int WMPAR_SORTER_EXCEPTION                = 6;
	public static final int WMPAR_IMAGES_READY                    = 7;
	public static final int WMPAR_SNIPPETS_READY                  = 8;
	public static final int WMPAR_DOC_COMPLETED                   = 9;
	public static final int WMPAR_STANDBY                         =10;
	public static final int WMPAR_MAGCARD                         =11;
	public static final int WMPAR_SET_DOWNSTREAM_OPTIONS          =12;
	public static final int WMPAR_COMPRESSED_IMG_FOR_DECISION     =13;

	public static final int ERROR_MIN_STR_LEN = 256;

	public static final int AGP_UNLIMITED_LINES  = 0;
	public static final int AGP_2_LINES          = 2;
	public static final int AGP_1_LINE           = 1;

	public static final int FEEDER_FULL       = 0;
	public static final int FEEDER_HALF       =50;
	public static final int FEEDER_SMALL      =30;
	public static final int FEEDER_ONE        = 1;

	public static final int DOC_TYPE_CHEQUE   = 0;
	public static final int DOC_TYPE_CARD     = 1;

	public static final int MAGCARD_ERROR_NONE      = 0;
	public static final int MAGCARD_ERROR_BASE      = MAGCARD_ERROR_NONE;
	public static final int MAGCARD_ERROR_PARITY    =(MAGCARD_ERROR_BASE+1);
	public static final int MAGCARD_ERROR_STANDARD  =(MAGCARD_ERROR_BASE+2);
	public static final int MAGCARD_ERROR_DIRECTION =(MAGCARD_ERROR_BASE+3);

	public static final int MAGCARD_MIN_BUFFER_LEN  = (512);

	public static final int OCR1_OCRA          = 0x0001;  
	public static final int OCR1_OCRB          = 0x0002;  
	public static final int OCR1_OCRAB         = 0x0003;  
	public static final int OCR1_OCRBUK        = 0x0004;  
	public static final int OCR1_E13BO         = 0x0005; 
	public static final int OCR1_E13BOXOCRBUK  = 0x0006;  
	public static final int OCR1_OCRAALNUM     = 0x0007;  
	public static final int OCR1_OCRBALNUM     = 0x0008;  
	public static final int OCR1_OCRB1403      = 0x0009;  
	public static final int OCR1_OCRAN         = 0x000A;  
	//
	public static final int OCR1_BC128         = 0x0010; 
	public static final int OCR1_BC39          = 0x0011;  
	public static final int OCR1_BC2OF5        = 0x0012; 
	public static final int OCR1_BCUPCA        = 0x0013;  
	public static final int OCR1_BCEAN13       = 0x0014;  
	public static final int OCR1_BCUPCE        = 0x0015; 
	public static final int OCR1_BCEAN8        = 0x0016;  
	//
	public static final int OCR1_BCPDF417      = 0x0017;  
	//
	public static final int OCR1_CMC7O         = 0x0018;  
	//
	// VisionS
	public static final int OCR1_BCCODABAR     = 0x0019;  
	public static final int OCR1_BCUCCEAN128   = 0x001A;  
	public static final int OCR1_BCAUTO        = 0x001B;  

	public static final int PRT_SRC_FILE     = 0;
	public static final int PRT_SRC_MEM_PTR  = 1;

	public static final int COUNTER_BASE           = (0);
	public static final int COUNTER_DOCS           = (COUNTER_BASE);
	public static final int COUNTER_CARDS          = (COUNTER_DOCS+1);
	public static final int COUNTER_FRANKING       = (COUNTER_CARDS+1);
	public static final int COUNTER_FIRST          = (COUNTER_DOCS);
	public static final int COUNTER_LAST           = (COUNTER_FRANKING);
	public static final int COUNTER_VALUES         = ((COUNTER_LAST-COUNTER_FIRST)+1);

	public static final int DEVICE_FEATURE_BASE                   = (0);

	public static final int DEVICE_FEATURE_DEVICE_TYPE            =  (DEVICE_FEATURE_BASE);
	public static final int DEVICE_FEATURE_SN                     =  (DEVICE_FEATURE_DEVICE_TYPE+1);
	public static final int DEVICE_FEATURE_SN_IDCARD              =  (DEVICE_FEATURE_SN+1);
	public static final int DEVICE_FEATURE_EXTERNAL_IDCARD        =  (DEVICE_FEATURE_SN_IDCARD+1);
	public static final int DEVICE_FEATURE_SN_EXTERNAL_IDCARD     =  (DEVICE_FEATURE_EXTERNAL_IDCARD+1);
	public static final int DEVICE_FEATURE_DPM                    =  (DEVICE_FEATURE_SN_EXTERNAL_IDCARD+1);
	public static final int DEVICE_FEATURE_FEEDER_LIMIT           =  (DEVICE_FEATURE_DPM+1);
	public static final int DEVICE_FEATURE_FEEDER_SD              =  (DEVICE_FEATURE_FEEDER_LIMIT+1);
	public static final int DEVICE_FEATURE_MICR_E13B              =  (DEVICE_FEATURE_FEEDER_SD+1);
	public static final int DEVICE_FEATURE_MICR_CMC7              =  (DEVICE_FEATURE_MICR_E13B+1);
	public static final int DEVICE_FEATURE_MICR_AUTO              =  (DEVICE_FEATURE_MICR_CMC7+1);
	public static final int DEVICE_FEATURE_MICR_OCR_E13B          =  (DEVICE_FEATURE_MICR_AUTO+1);
	public static final int DEVICE_FEATURE_MICR_OCR_CMC7          =  (DEVICE_FEATURE_MICR_OCR_E13B+1);
	public static final int DEVICE_FEATURE_PRINTER_TYPE           =  (DEVICE_FEATURE_MICR_OCR_CMC7+1);
	public static final int DEVICE_FEATURE_PRINTER_LINES          =  (DEVICE_FEATURE_PRINTER_TYPE+1);
	public static final int DEVICE_FEATURE_PRINTER_BITMAP         =  (DEVICE_FEATURE_PRINTER_LINES+1);
	public static final int DEVICE_FEATURE_PRINTER_BITMAP_HEIGHT  =  (DEVICE_FEATURE_PRINTER_BITMAP+1);

	public static final int DEVICE_FEATURE_IMAGE_FRONT            =  (DEVICE_FEATURE_PRINTER_BITMAP_HEIGHT+1);
	public static final int DEVICE_FEATURE_IMAGE_FRONT_FAST_COLOR =  (DEVICE_FEATURE_IMAGE_FRONT+1);
	public static final int DEVICE_FEATURE_IMAGE_FRONT_TRUE_COLOR =  (DEVICE_FEATURE_IMAGE_FRONT_FAST_COLOR+1);
	public static final int DEVICE_FEATURE_IMAGE_FRONT_FAST_DROPOUT= (DEVICE_FEATURE_IMAGE_FRONT_TRUE_COLOR+1);
	public static final int DEVICE_FEATURE_IMAGE_FRONT_DPI         = (DEVICE_FEATURE_IMAGE_FRONT_FAST_DROPOUT+1);
	public static final int DEVICE_FEATURE_IMAGE_FRONT_FAST_DROPOUT_IR = (DEVICE_FEATURE_IMAGE_FRONT_DPI+1);

	public static final int DEVICE_FEATURE_IMAGE_REAR               = (DEVICE_FEATURE_IMAGE_FRONT_FAST_DROPOUT_IR+1);
	public static final int DEVICE_FEATURE_IMAGE_REAR_FAST_COLOR    = (DEVICE_FEATURE_IMAGE_REAR+1);
	public static final int DEVICE_FEATURE_IMAGE_REAR_TRUE_COLOR    = (DEVICE_FEATURE_IMAGE_REAR_FAST_COLOR+1);
	public static final int DEVICE_FEATURE_IMAGE_REAR_FAST_DROPOUT  = (DEVICE_FEATURE_IMAGE_REAR_TRUE_COLOR+1);
	public static final int DEVICE_FEATURE_IMAGE_REAR_DPI           = (DEVICE_FEATURE_IMAGE_REAR_FAST_DROPOUT+1);
	public static final int DEVICE_FEATURE_IMAGE_REAR_FAST_DROPOUT_IR  = (DEVICE_FEATURE_IMAGE_REAR_DPI+1);

	public static final int DEVICE_FEATURE_OCR_AB                   = (DEVICE_FEATURE_IMAGE_REAR_FAST_DROPOUT_IR+1);
	public static final int DEVICE_FEATURE_OCR_MICR                 = (DEVICE_FEATURE_OCR_AB+1);
	public static final int DEVICE_FEATURE_OCR_BARCODE_1D           = (DEVICE_FEATURE_OCR_MICR+1);
	public static final int DEVICE_FEATURE_OCR_BARCODE_2D           = (DEVICE_FEATURE_OCR_BARCODE_1D+1);
	public static final int DEVICE_FEATURE_IQA                      = (DEVICE_FEATURE_OCR_BARCODE_2D+1);

	public static final int DEVICE_FEATURE_POCKETS                  = (DEVICE_FEATURE_IQA+1);

	public static final int DEVICE_FEATURE_ROHS_COMPLIANT           = (DEVICE_FEATURE_POCKETS+1);

	public static final int DEVICE_FEATURE_SMART_JET                = (DEVICE_FEATURE_ROHS_COMPLIANT+1);

	public static final int DEVICE_FEATURE_MAGCARD                  = (DEVICE_FEATURE_SMART_JET+1);

	public static final int DEVICE_FEATURE_OCR_ENGINE               = (DEVICE_FEATURE_MAGCARD+1);
	public static final int DEVICE_FEATURE_BARCODE_1D_ENGINE        = (DEVICE_FEATURE_OCR_ENGINE+1);
	public static final int DEVICE_FEATURE_BARCODE_2D_ENGINE        = (DEVICE_FEATURE_BARCODE_1D_ENGINE+1);
	public static final int DEVICE_FEATURE_MICR_OCR_ENGINE          = (DEVICE_FEATURE_BARCODE_2D_ENGINE+1);

	public static final int DEVICE_FEATURE_ULTRASONIC_DFD           = (DEVICE_FEATURE_MICR_OCR_ENGINE+1);

	public static final int DEVICE_FEATURE_CARDS                    = (DEVICE_FEATURE_ULTRASONIC_DFD+1);

	public static final int DEVICE_FEATURE_LAST                     = (DEVICE_FEATURE_CARDS);

	public static final int DEVICE_MYVISIONX  = 0;
	public static final int DEVICE_VISIONX    = 1;
	public static final int DEVICE_VISIONS    = 2;
	public static final int DEVICE_IDEAL      = 3;

	public static final int DEVICE_SN_BUFFER_LEN  = 11;

	public static final int DEVICE_PRINTER_DISABLED     = 0;
	public static final int DEVICE_PRINTER_SINGLE_LINE  = 1;
	public static final int DEVICE_PRINTER_AGP          = 2;

	public static final int DEVICE_FEATURE_NO   = 0;
	public static final int DEVICE_FEATURE_YES  = 1;

	public static final int FEEDING_STARTSTOP = 0;
	public static final int FEEDING_FLOWMODE  = 1;

	public static final int ENDORSEMENT_AREAS         = (8);

	public static final int ENDORSEMENT_AREA_BASE     = (0);
	public static final int ENDORSEMENT_AREA_PAYEE    = (ENDORSEMENT_AREA_BASE);
	public static final int ENDORSEMENT_AREA_BOFD     = (ENDORSEMENT_AREA_PAYEE   + 1);
	public static final int ENDORSEMENT_AREA_TRANSIT  = (ENDORSEMENT_AREA_BOFD    + 1);
	public static final int ENDORSEMENT_AREA_CUSTOM1  = (ENDORSEMENT_AREA_TRANSIT + 1);
	public static final int ENDORSEMENT_AREA_CUSTOM2  = (ENDORSEMENT_AREA_CUSTOM1 + 1);
	public static final int ENDORSEMENT_AREA_CUSTOM3  = (ENDORSEMENT_AREA_CUSTOM2 + 1);
	public static final int ENDORSEMENT_AREA_CUSTOM4  = (ENDORSEMENT_AREA_CUSTOM3 + 1);
	public static final int ENDORSEMENT_AREA_CUSTOM5  = (ENDORSEMENT_AREA_CUSTOM4 + 1);

	public static final int ENDORSEMENT_AREA_LAST     = (ENDORSEMENT_AREA_CUSTOM5);

	public static final int ENDORSEMENT_PARAM_BASE     = (0);

	public static final int ENDORSEMENT_PARAM_RECT     = (ENDORSEMENT_PARAM_BASE);
	public static final int ENDORSEMENT_PARAM_UNIT     = (ENDORSEMENT_PARAM_RECT   + 1);
	public static final int ENDORSEMENT_PARAM_FONT     = (ENDORSEMENT_PARAM_UNIT   + 1);
	public static final int ENDORSEMENT_PARAM_COLOR    = (ENDORSEMENT_PARAM_FONT   + 1);
	public static final int ENDORSEMENT_PARAM_FLAGS    = (ENDORSEMENT_PARAM_COLOR  + 1);
	public static final int ENDORSEMENT_PARAM_ROTATION = (ENDORSEMENT_PARAM_FLAGS  + 1);
	public static final int ENDORSEMENT_PARAM_LAST     = (ENDORSEMENT_PARAM_ROTATION);
	public static final int ENDORSEMENT_PARAMS         = (6);

	public static final int ENDORSEMENT_UNITS          = (2);
	public static final int ENDORSEMENT_UNIT_MM        = (0);
	public static final int ENDORSEMENT_UNIT_MILS      = (1);
	public static final int ENDORSEMENT_UNIT_LAST      = (ENDORSEMENT_UNIT_MILS);

	public static final int ENDORSEMENT_FLAG_LEFT      = (0x00000001);
	public static final int ENDORSEMENT_FLAG_CENTER    = (0x00000002);
	public static final int ENDORSEMENT_FLAG_RIGHT     = (0x00000004);
	public static final int ENDORSEMENT_FLAG_WORD_WRAP = (0x00000008);
	public static final int ENDORSEMENT_FLAGS_MASK     = (~(ENDORSEMENT_FLAG_LEFT|ENDORSEMENT_FLAG_CENTER|ENDORSEMENT_FLAG_RIGHT|ENDORSEMENT_FLAG_WORD_WRAP));

	public static final int ENDORSEMENT_ROTATE_0    = (0);
	public static final int ENDORSEMENT_ROTATE_90   = (1);
	public static final int ENDORSEMENT_ROTATE_180  = (2);
	public static final int ENDORSEMENT_ROTATE_270  = (3);
	public static final int ENDORSEMENT_ROTATE_LAST = (ENDORSEMENT_ROTATE_270);

	public static final int ENDORSEMENT_BMP_FILE   = (0);
	public static final int ENDORSEMENT_BMP_LAST   = (ENDORSEMENT_BMP_FILE);

	public static final int VAPI_ENGINE_BASE = (0);
	public static final int VAPI_ENGINE_VX   = (VAPI_ENGINE_BASE);  
	public static final int VAPI_ENGINE_VS   = (VAPI_ENGINE_VX+1);  
	public static final int VAPI_ENGINE_ID   = (VAPI_ENGINE_VS+1);  
	public static final int VAPI_ENGINE_MAX  = (VAPI_ENGINE_ID);

	public static final int RET_OK  = 0; 

	public static final int VAPI_ERR_NONE                       = RET_OK;
	public static final int VAPI_ERR_BASE                       = VAPI_ERR_NONE;
	public static final int VAPI_ERR_ENGINE_LOAD_FAILED         = (VAPI_ERR_BASE+1);  
	public static final int VAPI_ERR_FUNCTION_NOT_SUPPORTED     = (VAPI_ERR_BASE+2);  
	public static final int VAPI_ERR_INVALID_PARAM              = (VAPI_ERR_BASE+3); 
	public static final int VAPI_ERR_INTERNAL                   = (VAPI_ERR_BASE+4);  

	public static final int _VAPI_ERR_LENGTH                    = (5);

	public static final int API_ERR_NONE                      = 0;   
	public static final int API_ERR_DEVICE_CREATE             = 1;   
	public static final int API_ERR_BRIDGE_THREAD             = 2;   
	public static final int API_ERR_POLLING_THREAD            = 3;  
	public static final int API_ERR_COMPRESSION_THREAD        = 4;  
	public static final int API_ERR_OCR_MANAGER               = 5;   
	public static final int API_ERR_OCR_NOT_ENABLED           = 6;   
	public static final int API_ERR_BUFF_ALLOC                = 7;   
	public static final int API_ERR_NO_USB_PORT_AVAILABLE     = 8;   
	public static final int API_ERR_LOG                       = 9;   
	public static final int API_ERR_INVALID_DEV_ID            = 10; 
	public static final int API_ERR_INVALID_DEV_OBJ           = 11;  
	public static final int API_ERR_INVALID_PARAM             = 12;  
	public static final int API_ERR_INVALID_STATE             = 13;  
	public static final int API_ERR_DEVICE                    = 14;  

	public static final int API_ERR_USB                       = 15;  

	public static final int API_ERR_FPGA_PROGRAMMING         =  16;  
	public static final int API_ERR_E2PROM_WRITE             =  17;  
	public static final int API_ERR_E2PROM_READ              =  18;  
	public static final int API_ERR_SET_TIME_LEDS            =  19;  
	public static final int API_ERR_SET_GAINS                =  20;  
	public static final int API_ERR_SET_OFFSETS              =  21;  
	public static final int API_ERR_SERIAL_PORT              =  22;  
	public static final int API_ERR_SEND_SERIAL_COMMAND      =  23;  
	public static final int API_ERR_NOT_AVAILABLE_DEVICE     =  24;  

	public static final int API_ERR_TRANSFER_THREAD          =  25;  
	public static final int API_ERR_INTERNAL                 =  26; 

	public static final int _API_ERR_LENGTH                  =  27;

	public static final int DEVICE_ERR_NONE                          =  0;  
	public static final int DEVICE_ERR_UNKNOWN_SORTER_ERROR          =  1; 

	public static final int DEVICE_ERR_USB                           =  2;  
	public static final int DEVICE_ERR_USB_RX_CRC                    =  3;  

	public static final int DEVICE_ERR_WAIT_FEED_DONE_TIMEOUT        =  4;  
	public static final int DEVICE_ERR_WAIT_LAST_DOC_POCKETED_TIMEOUT = 5;  
	public static final int DEVICE_ERR_READ_SORTER_STATUS             = 6;  

	public static final int DEVICE_ERR_SORTER_ERROR_PENDING          = 7;  

	public static final int DEVICE_ERR_COMMUNICATION_FAILURE         =  8;  
	public static final int DEVICE_ERR_FEED_FAILURE                  =  9;  

	public static final int DEVICE_ERR_FULL_POCKET                   =  10; 
	public static final int DEVICE_ERR_SAFETY                        =  11; 
	public static final int DEVICE_ERR_GET_LAST_DOC_POCKETED_ID      =  12; 
	public static final int DEVICE_ERR_FEED_DOCUMENT                 =  13; 
	public static final int DEVICE_ERR_TRACK_NOT_CLEAR               =  14; 
	public static final int DEVICE_ERR_SET_POCKET                    =  15; 
	public static final int DEVICE_ERR_GET_LAST_DOC_ID               =  16; 

	public static final int DEVICE_ERR_READ_MICR_SIZE                =  17; 
	public static final int DEVICE_ERR_READ_MICR_WAVEFORM_CHUNK      =  18; 
	public static final int DEVICE_ERR_DIFFERENT_MICR_SIZE           =  19; 
	public static final int DEVICE_ERR_MICR_BUFFER_OVERFLOW          =  20; 
	public static final int DEVICE_ERR_MICR_READING                  =  21; 

	public static final int DEVICE_ERR_ACQUISITION_FAILED            =  22; 
	public static final int DEVICE_ERR_COMPRESSION_ERR               =  23; 
	public static final int DEVICE_ERR_READ_ERROR                    =  24; 
	public static final int DEVICE_ERR_CREATE_COMPENSATION_TABLES    =  25; 
	public static final int DEVICE_ERR_ID_CARD                       =  26; 
	public static final int DEVICE_ERR_DEVICE_ENABLING               =  27; 
	public static final int DEVICE_ERR_LOADING_OCR                   =  28; 
	public static final int DEVICE_ERR_CONNECTION_TIMEOUT            =  29; 
	public static final int DEVICE_ERR_FEEDER_EMPTY                  =  30; 
	public static final int DEVICE_ERR_FREE_TRACK_FAILED             =  31; 
	public static final int DEVICE_ERR_SOFTWARE_OVERLOAD             =  32; 
	public static final int DEVICE_ERR_STANDBY                       =  33; 
	public static final int DEVICE_ERR_NOT_COMPATIBLE_FW             =  34; 
	public static final int DEVICE_ERR_INVALID_SEND_PRINTER          =  35; 

	public static final int DEVICE_ERR_UNSUPPORTED_ID_CARD           =  36; 

	public static final int DEVICE_ERR_INVALID_PARAMETERS            =  37; 

	public static final int DEVICE_ERR_FEEDER_LIMIT                  =  38; 

	public static final int DEVICE_ERR_WAITING_FEEDER_EMPTY          =  39;

	public static final int DEVICE_ERR_FEEDER_LIMIT_RESET            =  40; 
	public static final int DEVICE_ERR_NOT_AVAILABLE_MAX_DPM         =  41; 
	public static final int DEVICE_ERR_NOT_CALIBRATED_IMAGE          =  42;
	public static final int DEVICE_ERR_UPGRADE_UNSUCCESSFUL          =  43; 
	public static final int DEVICE_ERR_NO_PREREQUISITE_FOR_UPGRADE   =  44;

	public static final int DEVICE_ERR_BUTTON_STOP                   =  47; 
	public static final int DEVICE_ERR_BUTTON_JAM                    =  48;  

	public static final int DEVICE_ERR_INVALID_STATE                 =  49; 

	public static final int DEVICE_ERR_DEFAULT_POCKET                =  50; 

	public static final int DEVICE_ERR_US_DFD_SELF_TEST              =  51; 

	public static final int DEVICE_ERR_MISSING_FRANKING              =  52; 

	public static final int DEVICE_ERR_FRANKING_FAILED               =  53; 

	public static final int _DEVICE_ERR_LENGTH                       =  54;

	public static final int USB_ERR_NONE                   = 0;  
	public static final int USB_ERR_INVALID_DEVICE_NAME    = 1;  
	public static final int USB_ERR_OPEN_DRIVER            = 2;  
	public static final int USB_ERR_CLOSE_DRIVER           = 3;  
	public static final int USB_ERR_GET_PIPE_INFO          = 4;  
	public static final int USB_ERR_GET_DEVICE_DESCRIPTOR  = 5; 
	public static final int USB_ERR_DEVICE_IO_CONTROL      = 6;  
	public static final int USB_ERR_WRITE_BULK             = 7;  
	public static final int USB_ERR_READ_BULK              = 8;  
	public static final int USB_ERR_WRITE_CONTROL          = 9;  
	public static final int USB_ERR_READ_CONTROL           = 10; 
	public static final int USB_ERR_GET_LINK_STATE         = 11; 
	public static final int USB_ERR_SEND_LINK_MESSAGE      = 12; 
	public static final int USB_ERR_RECEIVE_LINK_MESSAGE   = 13; 
	public static final int USB_ERR_PROGRAM_FPGA           = 14; 
	public static final int USB_ERR_CHECK_FPGA             = 15; 
	public static final int USB_ERR_WRITE_E2PROM           = 16; 
	public static final int USB_ERR_READ_E2PROM            = 17; 
	public static final int USB_ERR_SET_TIME_LEDS          = 18; 
	public static final int USB_ERR_SET_GAINS              = 19; 
	public static final int USB_ERR_SET_OFFSETS            = 20; 
	public static final int USB_ERR_WRITE_DMA_BULK         = 21; 
	public static final int USB_ERR_READ_DMA_BULK_PARAM    = 22; 
	public static final int USB_ERR_READ_DMA_BULK_SETUP    = 23; 
	public static final int USB_ERR_READ_DMA_BULK_PHASE1   = 24; 
	public static final int USB_ERR_READ_DMA_BULK_PHASE2   = 25; 
	public static final int USB_ERR_READ_DMA_BULK_CLEAR    = 26; 
	public static final int USB_ERR_READ_ID_CARD           = 27; 
	public static final int USB_ERR_WRITE_ID_CARD          = 28; 
	public static final int USB_ERR_SET_DPM                = 29; 

	public static final int USB_INVALID_PARAM              = 30; 
	public static final int USB_INVALID_DEVICE             = 31; 
	public static final int USB_SYSTEM_ERROR               = 32; 

	public static final int _USB_ERR_LENGTH                = 33;

	public static final int ERR_GENERAL       = 0x00;  
	public static final int ERR_COMM          = 0x01;   
	public static final int ERR_INIT          = 0x02;   
	public static final int ERR_PERIPHERAL    = 0x03;   
	public static final int ERR_TRANSPORT     = 0x04;   

	public static final int GENERAL           = 0x00;
	public static final int COMMUNICATION     = 0x01;
	public static final int READER_MODULE     = 0x02;
	public static final int ENCODER_MODULE    = 0x03;
	public static final int SORTER_MODULE     = 0x04;
	public static final int MICR_DEVICE       = 0x05;
	public static final int IMAGE             = 0x06;
	public static final int PRINTER1          = 0x07;
	public static final int PRINTER2          = 0x08;
	public static final int ENCODING_DEVICE   = 0x09;
	public static final int IMAGE2            = 0x0A;
	public static final int DROP_STATION      = 0x0B;
	public static final int OCR               = 0x0C;
	public static final int BARCODE           = 0x0D;
	public static final int MOTOR             = 0x0E;

	public static final int ERR_NONE          = 0x00;   

	public static final int ERR_CHECKSUM      = 0x01;    
	public static final int ERR_UNKNOWN_CMD   = 0x02;
	public static final int ERR_INVALID_CMD   = 0x03;
	public static final int ERR_DOC_ID        = 0x04;    
	public static final int ERR_POCKET        = 0x05;    
	public static final int ERR_SOURCE        = 0x06;    
	public static final int ERR_PREV_POCKET   = 0x07;    
	public static final int ERR_PARAM         = 0x08;    

	public static final int ERR_INIT_PHOTOS   = 0x01;    

	public static final int ERR_MICR_WAIT_TO  = 0x01;    
	public static final int ERR_MICR_BULK_TO  = 0x02;    

	public static final int ERR_DOC_LOST        = 0x01;    
	public static final int ERR_DOC_LENGTH      = 0x02;    
	public static final int ERR_DOC_FEED        = 0x03;    
	public static final int ERR_FREE_TRACK      = 0x04;    
	public static final int ERR_DOC_DEST        = 0x05;    
	public static final int ERR_FULL_POCKET     = 0x06;    
	public static final int ERR_OPEN_POCKET     = 0x07;    
	public static final int ERR_DOUBLE_FEEDING  = 0x08;    
	public static final int ERR_DEFAULT_POCKET  = 0x09;    
	public static final int ERR_BUSY_PHOTO      = 0x0A;    
	public static final int ERR_PRINTER         = 0x0B;    
	public static final int ERR_IMAGE           = 0x0C;    
	public static final int ERR_BUFFER_BUSY     = 0x0D;    
	public static final int ERR_BUTTON_STOP     = 0x0E;    
	public static final int ERR_BUTTON_JAM      = 0x0F;    
	public static final int ERR_DOC_IN_ADVANCE  = 0x10;    
	public static final int ERR_DOC_SHORT       = 0x11;    
	public static final int ERR_OPENED_COVER    = 0x01;    

	public String getVersion();

	public int setDeviceEngine(int engineSelector);

	public int getError();

	public String getErrorString();


	public String getApiRelease(); 


	public String getDriverRelease(); 


	public String getFwVersion(); 


	public String getSerialNumber(); 


	public String readCryptedIDCard();


	public String getIDCardDescription(int[] pLen, Devices[] devices); 


	public boolean upGradeIDCard(int len); 

	public Object getDeviceFeature(int deviceFeature);


	public int getUsbError();

	public String getUsbErrorString();

	public int getDeviceError(); 


	public String getDeviceErrorString(); 

	public int getApiError(); 


	public String getApiErrorString(); 

	public int getSorterError();

	public String getSorterErrorString(); 

	public int getDeviceState(); 

	public String getDeviceStateString();

	public int startUp(HWND handle);

	public boolean shutDown(); 

	public boolean changeParameters();

	public boolean onLine();

	public boolean setSorterParameter(short paramId, short paramValue);

	public Parameter getSorterParameter(short paramId); 

	public boolean setDeviceParameters(DeviceParameters deviceParam);

	public DeviceParameters getDeviceParameters(); 

	public boolean setImageAdjustment(short constrast, short brightness, boolean front); 

	public boolean setMaxDPM(int dpm); 

	public int getMaxDPM(); 

	public boolean setAGPLines(byte lines); 

	public boolean setFeederLimit(byte limit);

	public boolean setHandDropDly(int dly); 

	public byte getAvailablePockets(); 

	public boolean setMaxPocket(byte pocket);

	public boolean setFeedingMode(byte mode); 

	public boolean setVirtualEndorsementProperty(int areaID, int propID, int[] pData);

	public int[] getVirtualEndorsementProperty(int areaID, int propID); 

	public boolean isFeederEmpty();

	public boolean startFeeding(); 

	public boolean stopFeeding(); 

	public boolean freeTrack(int pocket);

	public boolean setPocket(int docNumber, int pocket);

	public int getDocumentLength(int docNumber, int[] docLength); 

	public String getMicrCodeline(); 

	public String getOCRCodeline(byte[] pBmp, int font, int threshold); 

	public boolean sendPrinterData(int dwHead, LogFont logFont, byte[] sText, int dwTextOffset, byte[] sImgPath, int mgOffset, int dwImgSrcType);

	public boolean setVirtualEndorsement(int AreaID, byte[] sText, byte[] sBmpPath, int bmpSrcType);

	public boolean freeImagesBuffer(ImagesStruct[] imagesStruct);

	public boolean freeSnippetBuffer(ImagesStruct[] imagesStruct); 

	public boolean disableDownStreamImage(int DocID); 

	public boolean getDoubleFeedingResult(int dwDocID, boolean[] pbDetected);

	public boolean getFullPocketStatus(int[] pStatus, boolean bWarning); 

	public int getDocumentType(int DocID); 

	public boolean enableFranking(int trailingEdgeAlignment, int startPosition);

	public boolean isTrackFree();

	public boolean rs232SetBaud(int baudRate); 

	public boolean rs232Write(byte[] pBuffer); 

	public int rs232GetLen(); 

	public String rs232Read(int len);

	public int readPrinterDropsCounter(); 

	public boolean ResetPrinterDropsCounter(); 

	public int getPrinterCartridgeInfo(boolean[] bInserted); 

	public int getHistoricalCounter(int counterID); 

	public boolean resetHistoricalCounter(int counterID);

	public String getMagCardResult(int bufferLen);	

}
