package br.com.tecpoint.api.win32;


import com.sun.jna.Native;
import com.sun.jna.Structure;

/**
 * User32 DLL interface
 * @author Cirilo Veloso
 * @version 1.00
 * @see W32API
 */
public interface User32 extends W32API {
User32 INSTANCE = (User32) Native.loadLibrary(
"user32", User32.class, DEFAULT_OPTIONS); 
 

final int GWL_EXSTYLE = -20;
final int GWL_STYLE = -16;
final int GWL_WNDPROC = -4;
final int GWL_HINSTANCE = -6;
final int GWL_ID = -12;
final int GWL_USERDATA = -21;
final int DWL_DLGPROC = 4;
final int DWL_MSGRESULT = 0;
final int DWL_USER = 8;
final int WS_EX_COMPOSITED = 0x20000000;
final int WS_EX_LAYERED = 0x80000;
final int WS_EX_TRANSPARENT = 32;
 
public final int WM_DESTROY = 0x0002;
final int WM_CHANGECBCHAIN = 0x030D;
final int WM_DRAWCLIPBOARD = 0x0308;
 
int GetWindowLong(HWND hWnd, int nIndex);
 
int SetWindowLong(HWND hWnd, int nIndex, int dwNewLong);
 
interface WNDPROC extends StdCallCallback {
int callback(HWND hWnd, int uMsg, WPARAM uParam, LPARAM lParam);
LRESULT callWindowProc(LONG_PTR prevWndProc,HWND hWnd, int uMsg, WPARAM wParam, LPARAM lParam);
}
 
int SetWindowLong(HWND hWnd, int nIndex, WNDPROC proc);
 

int DestroyWindow(HWND hwnd);
 

final int PM_NOREMOVE = 0x0000;
final int PM_REMOVE = 0x0001;
final int PM_NOYIELD = 0x0002;
 
class MSG extends Structure {
public int hWnd;
public int message;
public short wParam;
public int lParam;
public int time;
}
  
int DefWindowProc(HWND hWnd, int msg, WPARAM wParam, LPARAM lParam);

LRESULT CallWindowProc(LONG_PTR prevWndProc,HWND hWnd, int uMsg, WPARAM wParam, LPARAM lParam);

}
